Index: IMGUI/imgui.cpp
===================================================================
--- IMGUI/imgui.cpp	(revision c58ebc3899e898504313cf42b9c1c05170b13f8f)
+++ IMGUI/imgui.cpp	(revision e66fd66b98dfb2d3f0f1af0833f4b2957f60d166)
@@ -2700,986 +3320,657 @@
 ImDrawData* ImGui::GetDrawData()
 {
-   ImGuiContext& g = *GImGui;
-   return g.DrawData.Valid ? &g.DrawData : NULL;
-}
-
-float ImGui::GetTime()
-{
-   return GImGui->Time;
+    ImGuiContext& g = *GImGui;
+    return g.DrawData.Valid ? &g.DrawData : NULL;
+}
+
+double ImGui::GetTime()
+{
+    return GImGui->Time;
 }
 
 int ImGui::GetFrameCount()
 {
-   return GImGui->FrameCount;
-}
-
-ImDrawList* ImGui::GetOverlayDrawList()
-{
-   return &GImGui->OverlayDrawList;
+    return GImGui->FrameCount;
+}
+
+ImDrawList* ImGui::GetBackgroundDrawList()
+{
+    return &GImGui->BackgroundDrawList;
+}
+
+ImDrawList* ImGui::GetForegroundDrawList()
+{
+    return &GImGui->ForegroundDrawList;
 }
 
 ImDrawListSharedData* ImGui::GetDrawListSharedData()
 {
-   return &GImGui->DrawListSharedData;
-}
-
-// This needs to be called before we submit any widget (aka in or before Begin)
-void ImGui::NavInitWindow(ImGuiWindow* window, bool force_reinit)
-{
-   ImGuiContext& g = *GImGui;
-   IM_ASSERT(window == g.NavWindow);
-   bool init_for_nav = false;
-   if (!(window->Flags & ImGuiWindowFlags_NoNavInputs))
-      if (!(window->Flags & ImGuiWindowFlags_ChildWindow) || (window->Flags & ImGuiWindowFlags_Popup) || (window->NavLastIds[0] == 0) || force_reinit)
-         init_for_nav = true;
-   if (init_for_nav)
-   {
-      SetNavID(0, g.NavLayer);
-      g.NavInitRequest = true;
-      g.NavInitRequestFromMove = false;
-      g.NavInitResultId = 0;
-      g.NavInitResultRectRel = ImRect();
-      NavUpdateAnyRequestFlag();
-   }
-   else
-   {
-      g.NavId = window->NavLastIds[0];
-   }
-}
-
-static ImVec2 NavCalcPreferredRefPos()
-{
-   ImGuiContext& g = *GImGui;
-   if (g.NavDisableHighlight || !g.NavDisableMouseHover || !g.NavWindow)
-      return ImFloor(g.IO.MousePos);
-
-   // When navigation is active and mouse is disabled, decide on an arbitrary position around the bottom left of the currently navigated item
-   const ImRect& rect_rel = g.NavWindow->NavRectRel[g.NavLayer];
-   ImVec2 pos = g.NavWindow->Pos + ImVec2(rect_rel.Min.x + ImMin(g.Style.FramePadding.x * 4, rect_rel.GetWidth()), rect_rel.Max.y - ImMin(g.Style.FramePadding.y, rect_rel.GetHeight()));
-   ImRect visible_rect = GetViewportRect();
-   return ImFloor(ImClamp(pos, visible_rect.Min, visible_rect.Max));   // ImFloor() is important because non-integer mouse position application in back-end might be lossy and result in undesirable non-zero delta.
-}
-
-static int FindWindowIndex(ImGuiWindow* window) // FIXME-OPT O(N)
-{
-   ImGuiContext& g = *GImGui;
-   for (int i = g.Windows.Size - 1; i >= 0; i--)
-      if (g.Windows[i] == window)
-         return i;
-   return -1;
-}
-
-static ImGuiWindow* FindWindowNavigable(int i_start, int i_stop, int dir) // FIXME-OPT O(N)
-{
-   ImGuiContext& g = *GImGui;
-   for (int i = i_start; i >= 0 && i < g.Windows.Size && i != i_stop; i += dir)
-      if (ImGui::IsWindowNavFocusable(g.Windows[i]))
-         return g.Windows[i];
-   return NULL;
-}
-
-float ImGui::GetNavInputAmount(ImGuiNavInput n, ImGuiInputReadMode mode)
-{
-   ImGuiContext& g = *GImGui;
-   if (mode == ImGuiInputReadMode_Down)
-      return g.IO.NavInputs[n];                         // Instant, read analog input (0.0f..1.0f, as provided by user)
-
-   const float t = g.IO.NavInputsDownDuration[n];
-   if (t < 0.0f && mode == ImGuiInputReadMode_Released)  // Return 1.0f when just released, no repeat, ignore analog input.
-      return (g.IO.NavInputsDownDurationPrev[n] >= 0.0f ? 1.0f : 0.0f);
-   if (t < 0.0f)
-      return 0.0f;
-   if (mode == ImGuiInputReadMode_Pressed)               // Return 1.0f when just pressed, no repeat, ignore analog input.
-      return (t == 0.0f) ? 1.0f : 0.0f;
-   if (mode == ImGuiInputReadMode_Repeat)
-      return (float)CalcTypematicPressedRepeatAmount(t, t - g.IO.DeltaTime, g.IO.KeyRepeatDelay * 0.80f, g.IO.KeyRepeatRate * 0.80f);
-   if (mode == ImGuiInputReadMode_RepeatSlow)
-      return (float)CalcTypematicPressedRepeatAmount(t, t - g.IO.DeltaTime, g.IO.KeyRepeatDelay * 1.00f, g.IO.KeyRepeatRate * 2.00f);
-   if (mode == ImGuiInputReadMode_RepeatFast)
-      return (float)CalcTypematicPressedRepeatAmount(t, t - g.IO.DeltaTime, g.IO.KeyRepeatDelay * 0.80f, g.IO.KeyRepeatRate * 0.30f);
-   return 0.0f;
-}
-
-// Equivalent of IsKeyDown() for NavInputs[]
-static bool IsNavInputDown(ImGuiNavInput n)
-{
-   return GImGui->IO.NavInputs[n] > 0.0f;
-}
-
-// Equivalent of IsKeyPressed() for NavInputs[]
-static bool IsNavInputPressed(ImGuiNavInput n, ImGuiInputReadMode mode)
-{
-   return ImGui::GetNavInputAmount(n, mode) > 0.0f;
-}
-
-static bool IsNavInputPressedAnyOfTwo(ImGuiNavInput n1, ImGuiNavInput n2, ImGuiInputReadMode mode)
-{
-   return (ImGui::GetNavInputAmount(n1, mode) + ImGui::GetNavInputAmount(n2, mode)) > 0.0f;
-}
-
-ImVec2 ImGui::GetNavInputAmount2d(ImGuiNavDirSourceFlags dir_sources, ImGuiInputReadMode mode, float slow_factor, float fast_factor)
-{
-   ImVec2 delta(0.0f, 0.0f);
-   if (dir_sources & ImGuiNavDirSourceFlags_Keyboard)
-      delta += ImVec2(GetNavInputAmount(ImGuiNavInput_KeyRight_, mode) - GetNavInputAmount(ImGuiNavInput_KeyLeft_, mode), GetNavInputAmount(ImGuiNavInput_KeyDown_, mode) - GetNavInputAmount(ImGuiNavInput_KeyUp_, mode));
-   if (dir_sources & ImGuiNavDirSourceFlags_PadDPad)
-      delta += ImVec2(GetNavInputAmount(ImGuiNavInput_DpadRight, mode) - GetNavInputAmount(ImGuiNavInput_DpadLeft, mode), GetNavInputAmount(ImGuiNavInput_DpadDown, mode) - GetNavInputAmount(ImGuiNavInput_DpadUp, mode));
-   if (dir_sources & ImGuiNavDirSourceFlags_PadLStick)
-      delta += ImVec2(GetNavInputAmount(ImGuiNavInput_LStickRight, mode) - GetNavInputAmount(ImGuiNavInput_LStickLeft, mode), GetNavInputAmount(ImGuiNavInput_LStickDown, mode) - GetNavInputAmount(ImGuiNavInput_LStickUp, mode));
-   if (slow_factor != 0.0f && IsNavInputDown(ImGuiNavInput_TweakSlow))
-      delta *= slow_factor;
-   if (fast_factor != 0.0f && IsNavInputDown(ImGuiNavInput_TweakFast))
-      delta *= fast_factor;
-   return delta;
-}
-
-static void NavUpdateWindowingHighlightWindow(int focus_change_dir)
-{
-   ImGuiContext& g = *GImGui;
-   IM_ASSERT(g.NavWindowingTarget);
-   if (g.NavWindowingTarget->Flags & ImGuiWindowFlags_Modal)
-      return;
-
-   const int i_current = FindWindowIndex(g.NavWindowingTarget);
-   ImGuiWindow* window_target = FindWindowNavigable(i_current + focus_change_dir, -INT_MAX, focus_change_dir);
-   if (!window_target)
-      window_target = FindWindowNavigable((focus_change_dir < 0) ? (g.Windows.Size - 1) : 0, i_current, focus_change_dir);
-   g.NavWindowingTarget = window_target;
-   g.NavWindowingToggleLayer = false;
-}
-
-// Window management mode (hold to: change focus/move/resize, tap to: toggle menu layer)
-static void ImGui::NavUpdateWindowing()
-{
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* apply_focus_window = NULL;
-   bool apply_toggle_layer = false;
-
-   bool start_windowing_with_gamepad = !g.NavWindowingTarget && IsNavInputPressed(ImGuiNavInput_Menu, ImGuiInputReadMode_Pressed);
-   bool start_windowing_with_keyboard = !g.NavWindowingTarget && g.IO.KeyCtrl && IsKeyPressedMap(ImGuiKey_Tab) && (g.IO.ConfigFlags & ImGuiConfigFlags_NavEnableKeyboard);
-   if (start_windowing_with_gamepad || start_windowing_with_keyboard)
-      if (ImGuiWindow* window = g.NavWindow ? g.NavWindow : FindWindowNavigable(g.Windows.Size - 1, -INT_MAX, -1))
-      {
-         g.NavWindowingTarget = window->RootWindowForTabbing;
-         g.NavWindowingHighlightTimer = g.NavWindowingHighlightAlpha = 0.0f;
-         g.NavWindowingToggleLayer = start_windowing_with_keyboard ? false : true;
-         g.NavInputSource = start_windowing_with_keyboard ? ImGuiInputSource_NavKeyboard : ImGuiInputSource_NavGamepad;
-      }
-
-   // Gamepad update
-   g.NavWindowingHighlightTimer += g.IO.DeltaTime;
-   if (g.NavWindowingTarget && g.NavInputSource == ImGuiInputSource_NavGamepad)
-   {
-      // Highlight only appears after a brief time holding the button, so that a fast tap on PadMenu (to toggle NavLayer) doesn't add visual noise
-      g.NavWindowingHighlightAlpha = ImMax(g.NavWindowingHighlightAlpha, ImSaturate((g.NavWindowingHighlightTimer - 0.20f) / 0.05f));
-
-      // Select window to focus
-      const int focus_change_dir = (int)IsNavInputPressed(ImGuiNavInput_FocusPrev, ImGuiInputReadMode_RepeatSlow) - (int)IsNavInputPressed(ImGuiNavInput_FocusNext, ImGuiInputReadMode_RepeatSlow);
-      if (focus_change_dir != 0)
-      {
-         NavUpdateWindowingHighlightWindow(focus_change_dir);
-         g.NavWindowingHighlightAlpha = 1.0f;
-      }
-
-      // Single press toggles NavLayer, long press with L/R apply actual focus on release (until then the window was merely rendered front-most)
-      if (!IsNavInputDown(ImGuiNavInput_Menu))
-      {
-         g.NavWindowingToggleLayer &= (g.NavWindowingHighlightAlpha < 1.0f); // Once button was held long enough we don't consider it a tap-to-toggle-layer press anymore.
-         if (g.NavWindowingToggleLayer && g.NavWindow)
-            apply_toggle_layer = true;
-         else if (!g.NavWindowingToggleLayer)
-            apply_focus_window = g.NavWindowingTarget;
-         g.NavWindowingTarget = NULL;
-      }
-   }
-
-   // Keyboard: Focus
-   if (g.NavWindowingTarget && g.NavInputSource == ImGuiInputSource_NavKeyboard)
-   {
-      // Visuals only appears after a brief time after pressing TAB the first time, so that a fast CTRL+TAB doesn't add visual noise
-      g.NavWindowingHighlightAlpha = ImMax(g.NavWindowingHighlightAlpha, ImSaturate((g.NavWindowingHighlightTimer - 0.15f) / 0.04f)); // 1.0f
-      if (IsKeyPressedMap(ImGuiKey_Tab, true))
-         NavUpdateWindowingHighlightWindow(g.IO.KeyShift ? +1 : -1);
-      if (!g.IO.KeyCtrl)
-         apply_focus_window = g.NavWindowingTarget;
-   }
-
-   // Keyboard: Press and Release ALT to toggle menu layer
-   // FIXME: We lack an explicit IO variable for "is the imgui window focused", so compare mouse validity to detect the common case of back-end clearing releases all keys on ALT-TAB
-   if ((g.ActiveId == 0 || g.ActiveIdAllowOverlap) && IsNavInputPressed(ImGuiNavInput_KeyMenu_, ImGuiInputReadMode_Released))
-      if (IsMousePosValid(&g.IO.MousePos) == IsMousePosValid(&g.IO.MousePosPrev))
-         apply_toggle_layer = true;
-
-   // Move window
-   if (g.NavWindowingTarget && !(g.NavWindowingTarget->Flags & ImGuiWindowFlags_NoMove))
-   {
-      ImVec2 move_delta;
-      if (g.NavInputSource == ImGuiInputSource_NavKeyboard && !g.IO.KeyShift)
-         move_delta = GetNavInputAmount2d(ImGuiNavDirSourceFlags_Keyboard, ImGuiInputReadMode_Down);
-      if (g.NavInputSource == ImGuiInputSource_NavGamepad)
-         move_delta = GetNavInputAmount2d(ImGuiNavDirSourceFlags_PadLStick, ImGuiInputReadMode_Down);
-      if (move_delta.x != 0.0f || move_delta.y != 0.0f)
-      {
-         const float NAV_MOVE_SPEED = 800.0f;
-         const float move_speed = ImFloor(NAV_MOVE_SPEED * g.IO.DeltaTime * ImMin(g.IO.DisplayFramebufferScale.x, g.IO.DisplayFramebufferScale.y)); // FIXME: Doesn't code variable framerate very well
-         g.NavWindowingTarget->Pos += move_delta * move_speed;
-         g.NavDisableMouseHover = true;
-         MarkIniSettingsDirty(g.NavWindowingTarget);
-      }
-   }
-
-   // Apply final focus
-   if (apply_focus_window && (g.NavWindow == NULL || apply_focus_window != g.NavWindow->RootWindowForTabbing))
-   {
-      g.NavDisableHighlight = false;
-      g.NavDisableMouseHover = true;
-      apply_focus_window = NavRestoreLastChildNavWindow(apply_focus_window);
-      ClosePopupsOverWindow(apply_focus_window);
-      FocusWindow(apply_focus_window);
-      if (apply_focus_window->NavLastIds[0] == 0)
-         NavInitWindow(apply_focus_window, false);
-
-      // If the window only has a menu layer, select it directly
-      if (apply_focus_window->DC.NavLayerActiveMask == (1 << 1))
-         g.NavLayer = 1;
-   }
-   if (apply_focus_window)
-      g.NavWindowingTarget = NULL;
-
-   // Apply menu/layer toggle
-   if (apply_toggle_layer && g.NavWindow)
-   {
-      ImGuiWindow* new_nav_window = g.NavWindow;
-      while ((new_nav_window->DC.NavLayerActiveMask & (1 << 1)) == 0 && (new_nav_window->Flags & ImGuiWindowFlags_ChildWindow) != 0 && (new_nav_window->Flags & (ImGuiWindowFlags_Popup | ImGuiWindowFlags_ChildMenu)) == 0)
-         new_nav_window = new_nav_window->ParentWindow;
-      if (new_nav_window != g.NavWindow)
-      {
-         ImGuiWindow* old_nav_window = g.NavWindow;
-         FocusWindow(new_nav_window);
-         new_nav_window->NavLastChildNavWindow = old_nav_window;
-      }
-      g.NavDisableHighlight = false;
-      g.NavDisableMouseHover = true;
-      NavRestoreLayer((g.NavWindow->DC.NavLayerActiveMask & (1 << 1)) ? (g.NavLayer ^ 1) : 0);
-   }
-}
-
-// NB: We modify rect_rel by the amount we scrolled for, so it is immediately updated.
-static void NavScrollToBringItemIntoView(ImGuiWindow* window, ImRect& item_rect_rel)
-{
-   // Scroll to keep newly navigated item fully into view
-   ImRect window_rect_rel(window->InnerRect.Min - window->Pos - ImVec2(1, 1), window->InnerRect.Max - window->Pos + ImVec2(1, 1));
-   //g.OverlayDrawList.AddRect(window->Pos + window_rect_rel.Min, window->Pos + window_rect_rel.Max, IM_COL32_WHITE); // [DEBUG]
-   if (window_rect_rel.Contains(item_rect_rel))
-      return;
-
-   ImGuiContext& g = *GImGui;
-   if (window->ScrollbarX && item_rect_rel.Min.x < window_rect_rel.Min.x)
-   {
-      window->ScrollTarget.x = item_rect_rel.Min.x + window->Scroll.x - g.Style.ItemSpacing.x;
-      window->ScrollTargetCenterRatio.x = 0.0f;
-   }
-   else if (window->ScrollbarX && item_rect_rel.Max.x >= window_rect_rel.Max.x)
-   {
-      window->ScrollTarget.x = item_rect_rel.Max.x + window->Scroll.x + g.Style.ItemSpacing.x;
-      window->ScrollTargetCenterRatio.x = 1.0f;
-   }
-   if (item_rect_rel.Min.y < window_rect_rel.Min.y)
-   {
-      window->ScrollTarget.y = item_rect_rel.Min.y + window->Scroll.y - g.Style.ItemSpacing.y;
-      window->ScrollTargetCenterRatio.y = 0.0f;
-   }
-   else if (item_rect_rel.Max.y >= window_rect_rel.Max.y)
-   {
-      window->ScrollTarget.y = item_rect_rel.Max.y + window->Scroll.y + g.Style.ItemSpacing.y;
-      window->ScrollTargetCenterRatio.y = 1.0f;
-   }
-
-   // Estimate upcoming scroll so we can offset our relative mouse position so mouse position can be applied immediately (under this block)
-   ImVec2 next_scroll = CalcNextScrollFromScrollTargetAndClamp(window);
-   item_rect_rel.Translate(window->Scroll - next_scroll);
-}
-
-static void ImGui::NavUpdate()
-{
-   ImGuiContext& g = *GImGui;
-   g.IO.WantSetMousePos = false;
-
-#if 0
-   if (g.NavScoringCount > 0) printf("[%05d] NavScoringCount %d for '%s' layer %d (Init:%d, Move:%d)\n", g.FrameCount, g.NavScoringCount, g.NavWindow ? g.NavWindow->Name : "NULL", g.NavLayer, g.NavInitRequest || g.NavInitResultId != 0, g.NavMoveRequest);
+    return &GImGui->DrawListSharedData;
+}
+
+void ImGui::StartMouseMovingWindow(ImGuiWindow* window)
+{
+    // Set ActiveId even if the _NoMove flag is set. Without it, dragging away from a window with _NoMove would activate hover on other windows.
+    // We _also_ call this when clicking in a window empty space when io.ConfigWindowsMoveFromTitleBarOnly is set, but clear g.MovingWindow afterward.
+    // This is because we want ActiveId to be set even when the window is not permitted to move.
+    ImGuiContext& g = *GImGui;
+    FocusWindow(window);
+    SetActiveID(window->MoveId, window);
+    g.NavDisableHighlight = true;
+    g.ActiveIdNoClearOnFocusLoss = true;
+    g.ActiveIdClickOffset = g.IO.MousePos - window->RootWindow->Pos;
+
+    bool can_move_window = true;
+    if ((window->Flags & ImGuiWindowFlags_NoMove) || (window->RootWindow->Flags & ImGuiWindowFlags_NoMove))
+        can_move_window = false;
+    if (can_move_window)
+        g.MovingWindow = window;
+}
+
+// Handle mouse moving window
+// Note: moving window with the navigation keys (Square + d-pad / CTRL+TAB + Arrows) are processed in NavUpdateWindowing()
+// FIXME: We don't have strong guarantee that g.MovingWindow stay synched with g.ActiveId == g.MovingWindow->MoveId.
+// This is currently enforced by the fact that BeginDragDropSource() is setting all g.ActiveIdUsingXXXX flags to inhibit navigation inputs,
+// but if we should more thoroughly test cases where g.ActiveId or g.MovingWindow gets changed and not the other.
+void ImGui::UpdateMouseMovingWindowNewFrame()
+{
+    ImGuiContext& g = *GImGui;
+    if (g.MovingWindow != NULL)
+    {
+        // We actually want to move the root window. g.MovingWindow == window we clicked on (could be a child window).
+        // We track it to preserve Focus and so that generally ActiveIdWindow == MovingWindow and ActiveId == MovingWindow->MoveId for consistency.
+        KeepAliveID(g.ActiveId);
+        IM_ASSERT(g.MovingWindow && g.MovingWindow->RootWindow);
+        ImGuiWindow* moving_window = g.MovingWindow->RootWindow;
+        if (g.IO.MouseDown[0] && IsMousePosValid(&g.IO.MousePos))
+        {
+            ImVec2 pos = g.IO.MousePos - g.ActiveIdClickOffset;
+            if (moving_window->Pos.x != pos.x || moving_window->Pos.y != pos.y)
+            {
+                MarkIniSettingsDirty(moving_window);
+                SetWindowPos(moving_window, pos, ImGuiCond_Always);
+            }
+            FocusWindow(g.MovingWindow);
+        }
+        else
+        {
+            ClearActiveID();
+            g.MovingWindow = NULL;
+        }
+    }
+    else
+    {
+        // When clicking/dragging from a window that has the _NoMove flag, we still set the ActiveId in order to prevent hovering others.
+        if (g.ActiveIdWindow && g.ActiveIdWindow->MoveId == g.ActiveId)
+        {
+            KeepAliveID(g.ActiveId);
+            if (!g.IO.MouseDown[0])
+                ClearActiveID();
+        }
+    }
+}
+
+// Initiate moving window when clicking on empty space or title bar.
+// Handle left-click and right-click focus.
+void ImGui::UpdateMouseMovingWindowEndFrame()
+{
+    ImGuiContext& g = *GImGui;
+    if (g.ActiveId != 0 || g.HoveredId != 0)
+        return;
+
+    // Unless we just made a window/popup appear
+    if (g.NavWindow && g.NavWindow->Appearing)
+        return;
+
+    // Click on empty space to focus window and start moving (after we're done with all our widgets)
+    if (g.IO.MouseClicked[0])
+    {
+        // Handle the edge case of a popup being closed while clicking in its empty space.
+        // If we try to focus it, FocusWindow() > ClosePopupsOverWindow() will accidentally close any parent popups because they are not linked together any more.
+        ImGuiWindow* root_window = g.HoveredRootWindow;
+        const bool is_closed_popup = root_window && (root_window->Flags & ImGuiWindowFlags_Popup) && !IsPopupOpen(root_window->PopupId, ImGuiPopupFlags_AnyPopupLevel);
+
+        if (root_window != NULL && !is_closed_popup)
+        {
+            StartMouseMovingWindow(g.HoveredWindow);
+
+            // Cancel moving if clicked outside of title bar
+            if (g.IO.ConfigWindowsMoveFromTitleBarOnly && !(root_window->Flags & ImGuiWindowFlags_NoTitleBar))
+                if (!root_window->TitleBarRect().Contains(g.IO.MouseClickedPos[0]))
+                    g.MovingWindow = NULL;
+
+            // Cancel moving if clicked over an item which was disabled or inhibited by popups (note that we know HoveredId == 0 already)
+            if (g.HoveredIdDisabled)
+                g.MovingWindow = NULL;
+        }
+        else if (root_window == NULL && g.NavWindow != NULL && GetTopMostPopupModal() == NULL)
+        {
+            // Clicking on void disable focus
+            FocusWindow(NULL);
+        }
+    }
+
+    // With right mouse button we close popups without changing focus based on where the mouse is aimed
+    // Instead, focus will be restored to the window under the bottom-most closed popup.
+    // (The left mouse button path calls FocusWindow on the hovered window, which will lead NewFrame->ClosePopupsOverWindow to trigger)
+    if (g.IO.MouseClicked[1])
+    {
+        // Find the top-most window between HoveredWindow and the top-most Modal Window.
+        // This is where we can trim the popup stack.
+        ImGuiWindow* modal = GetTopMostPopupModal();
+        bool hovered_window_above_modal = false;
+        if (modal == NULL)
+            hovered_window_above_modal = true;
+        for (int i = g.Windows.Size - 1; i >= 0 && hovered_window_above_modal == false; i--)
+        {
+            ImGuiWindow* window = g.Windows[i];
+            if (window == modal)
+                break;
+            if (window == g.HoveredWindow)
+                hovered_window_above_modal = true;
+        }
+        ClosePopupsOverWindow(hovered_window_above_modal ? g.HoveredWindow : modal, true);
+    }
+}
+
+static bool IsWindowActiveAndVisible(ImGuiWindow* window)
+{
+    return (window->Active) && (!window->Hidden);
+}
+
+static void ImGui::UpdateMouseInputs()
+{
+    ImGuiContext& g = *GImGui;
+
+    // Round mouse position to avoid spreading non-rounded position (e.g. UpdateManualResize doesn't support them well)
+    if (IsMousePosValid(&g.IO.MousePos))
+        g.IO.MousePos = g.LastValidMousePos = ImFloor(g.IO.MousePos);
+
+    // If mouse just appeared or disappeared (usually denoted by -FLT_MAX components) we cancel out movement in MouseDelta
+    if (IsMousePosValid(&g.IO.MousePos) && IsMousePosValid(&g.IO.MousePosPrev))
+        g.IO.MouseDelta = g.IO.MousePos - g.IO.MousePosPrev;
+    else
+        g.IO.MouseDelta = ImVec2(0.0f, 0.0f);
+    if (g.IO.MouseDelta.x != 0.0f || g.IO.MouseDelta.y != 0.0f)
+        g.NavDisableMouseHover = false;
+
+    g.IO.MousePosPrev = g.IO.MousePos;
+    for (int i = 0; i < IM_ARRAYSIZE(g.IO.MouseDown); i++)
+    {
+        g.IO.MouseClicked[i] = g.IO.MouseDown[i] && g.IO.MouseDownDuration[i] < 0.0f;
+        g.IO.MouseReleased[i] = !g.IO.MouseDown[i] && g.IO.MouseDownDuration[i] >= 0.0f;
+        g.IO.MouseDownDurationPrev[i] = g.IO.MouseDownDuration[i];
+        g.IO.MouseDownDuration[i] = g.IO.MouseDown[i] ? (g.IO.MouseDownDuration[i] < 0.0f ? 0.0f : g.IO.MouseDownDuration[i] + g.IO.DeltaTime) : -1.0f;
+        g.IO.MouseDoubleClicked[i] = false;
+        if (g.IO.MouseClicked[i])
+        {
+            if ((float)(g.Time - g.IO.MouseClickedTime[i]) < g.IO.MouseDoubleClickTime)
+            {
+                ImVec2 delta_from_click_pos = IsMousePosValid(&g.IO.MousePos) ? (g.IO.MousePos - g.IO.MouseClickedPos[i]) : ImVec2(0.0f, 0.0f);
+                if (ImLengthSqr(delta_from_click_pos) < g.IO.MouseDoubleClickMaxDist * g.IO.MouseDoubleClickMaxDist)
+                    g.IO.MouseDoubleClicked[i] = true;
+                g.IO.MouseClickedTime[i] = -g.IO.MouseDoubleClickTime * 2.0f; // Mark as "old enough" so the third click isn't turned into a double-click
+            }
+            else
+            {
+                g.IO.MouseClickedTime[i] = g.Time;
+            }
+            g.IO.MouseClickedPos[i] = g.IO.MousePos;
+            g.IO.MouseDownWasDoubleClick[i] = g.IO.MouseDoubleClicked[i];
+            g.IO.MouseDragMaxDistanceAbs[i] = ImVec2(0.0f, 0.0f);
+            g.IO.MouseDragMaxDistanceSqr[i] = 0.0f;
+        }
+        else if (g.IO.MouseDown[i])
+        {
+            // Maintain the maximum distance we reaching from the initial click position, which is used with dragging threshold
+            ImVec2 delta_from_click_pos = IsMousePosValid(&g.IO.MousePos) ? (g.IO.MousePos - g.IO.MouseClickedPos[i]) : ImVec2(0.0f, 0.0f);
+            g.IO.MouseDragMaxDistanceSqr[i] = ImMax(g.IO.MouseDragMaxDistanceSqr[i], ImLengthSqr(delta_from_click_pos));
+            g.IO.MouseDragMaxDistanceAbs[i].x = ImMax(g.IO.MouseDragMaxDistanceAbs[i].x, delta_from_click_pos.x < 0.0f ? -delta_from_click_pos.x : delta_from_click_pos.x);
+            g.IO.MouseDragMaxDistanceAbs[i].y = ImMax(g.IO.MouseDragMaxDistanceAbs[i].y, delta_from_click_pos.y < 0.0f ? -delta_from_click_pos.y : delta_from_click_pos.y);
+        }
+        if (!g.IO.MouseDown[i] && !g.IO.MouseReleased[i])
+            g.IO.MouseDownWasDoubleClick[i] = false;
+        if (g.IO.MouseClicked[i]) // Clicking any mouse button reactivate mouse hovering which may have been deactivated by gamepad/keyboard navigation
+            g.NavDisableMouseHover = false;
+    }
+}
+
+static void StartLockWheelingWindow(ImGuiWindow* window)
+{
+    ImGuiContext& g = *GImGui;
+    if (g.WheelingWindow == window)
+        return;
+    g.WheelingWindow = window;
+    g.WheelingWindowRefMousePos = g.IO.MousePos;
+    g.WheelingWindowTimer = WINDOWS_MOUSE_WHEEL_SCROLL_LOCK_TIMER;
+}
+
+void ImGui::UpdateMouseWheel()
+{
+    ImGuiContext& g = *GImGui;
+
+    // Reset the locked window if we move the mouse or after the timer elapses
+    if (g.WheelingWindow != NULL)
+    {
+        g.WheelingWindowTimer -= g.IO.DeltaTime;
+        if (IsMousePosValid() && ImLengthSqr(g.IO.MousePos - g.WheelingWindowRefMousePos) > g.IO.MouseDragThreshold * g.IO.MouseDragThreshold)
+            g.WheelingWindowTimer = 0.0f;
+        if (g.WheelingWindowTimer <= 0.0f)
+        {
+            g.WheelingWindow = NULL;
+            g.WheelingWindowTimer = 0.0f;
+        }
+    }
+
+    if (g.IO.MouseWheel == 0.0f && g.IO.MouseWheelH == 0.0f)
+        return;
+
+    ImGuiWindow* window = g.WheelingWindow ? g.WheelingWindow : g.HoveredWindow;
+    if (!window || window->Collapsed)
+        return;
+
+    // Zoom / Scale window
+    // FIXME-OBSOLETE: This is an old feature, it still works but pretty much nobody is using it and may be best redesigned.
+    if (g.IO.MouseWheel != 0.0f && g.IO.KeyCtrl && g.IO.FontAllowUserScaling)
+    {
+        StartLockWheelingWindow(window);
+        const float new_font_scale = ImClamp(window->FontWindowScale + g.IO.MouseWheel * 0.10f, 0.50f, 2.50f);
+        const float scale = new_font_scale / window->FontWindowScale;
+        window->FontWindowScale = new_font_scale;
+        if (!(window->Flags & ImGuiWindowFlags_ChildWindow))
+        {
+            const ImVec2 offset = window->Size * (1.0f - scale) * (g.IO.MousePos - window->Pos) / window->Size;
+            SetWindowPos(window, window->Pos + offset, 0);
+            window->Size = ImFloor(window->Size * scale);
+            window->SizeFull = ImFloor(window->SizeFull * scale);
+        }
+        return;
+    }
+
+    // Mouse wheel scrolling
+    // If a child window has the ImGuiWindowFlags_NoScrollWithMouse flag, we give a chance to scroll its parent
+
+    // Vertical Mouse Wheel scrolling
+    const float wheel_y = (g.IO.MouseWheel != 0.0f && !g.IO.KeyShift) ? g.IO.MouseWheel : 0.0f;
+    if (wheel_y != 0.0f && !g.IO.KeyCtrl)
+    {
+        StartLockWheelingWindow(window);
+        while ((window->Flags & ImGuiWindowFlags_ChildWindow) && ((window->ScrollMax.y == 0.0f) || ((window->Flags & ImGuiWindowFlags_NoScrollWithMouse) && !(window->Flags & ImGuiWindowFlags_NoMouseInputs))))
+            window = window->ParentWindow;
+        if (!(window->Flags & ImGuiWindowFlags_NoScrollWithMouse) && !(window->Flags & ImGuiWindowFlags_NoMouseInputs))
+        {
+            float max_step = window->InnerRect.GetHeight() * 0.67f;
+            float scroll_step = ImFloor(ImMin(5 * window->CalcFontSize(), max_step));
+            SetScrollY(window, window->Scroll.y - wheel_y * scroll_step);
+        }
+    }
+
+    // Horizontal Mouse Wheel scrolling, or Vertical Mouse Wheel w/ Shift held
+    const float wheel_x = (g.IO.MouseWheelH != 0.0f && !g.IO.KeyShift) ? g.IO.MouseWheelH : (g.IO.MouseWheel != 0.0f && g.IO.KeyShift) ? g.IO.MouseWheel : 0.0f;
+    if (wheel_x != 0.0f && !g.IO.KeyCtrl)
+    {
+        StartLockWheelingWindow(window);
+        while ((window->Flags & ImGuiWindowFlags_ChildWindow) && ((window->ScrollMax.x == 0.0f) || ((window->Flags & ImGuiWindowFlags_NoScrollWithMouse) && !(window->Flags & ImGuiWindowFlags_NoMouseInputs))))
+            window = window->ParentWindow;
+        if (!(window->Flags & ImGuiWindowFlags_NoScrollWithMouse) && !(window->Flags & ImGuiWindowFlags_NoMouseInputs))
+        {
+            float max_step = window->InnerRect.GetWidth() * 0.67f;
+            float scroll_step = ImFloor(ImMin(2 * window->CalcFontSize(), max_step));
+            SetScrollX(window, window->Scroll.x - wheel_x * scroll_step);
+        }
+    }
+}
+
+void ImGui::UpdateTabFocus()
+{
+    ImGuiContext& g = *GImGui;
+
+    // Pressing TAB activate widget focus
+    g.FocusTabPressed = (g.NavWindow && g.NavWindow->Active && !(g.NavWindow->Flags & ImGuiWindowFlags_NoNavInputs) && !g.IO.KeyCtrl && IsKeyPressedMap(ImGuiKey_Tab));
+    if (g.ActiveId == 0 && g.FocusTabPressed)
+    {
+        // Note that SetKeyboardFocusHere() sets the Next fields mid-frame. To be consistent we also
+        // manipulate the Next fields even, even though they will be turned into Curr fields by the code below.
+        g.FocusRequestNextWindow = g.NavWindow;
+        g.FocusRequestNextCounterRegular = INT_MAX;
+        if (g.NavId != 0 && g.NavIdTabCounter != INT_MAX)
+            g.FocusRequestNextCounterTabStop = g.NavIdTabCounter + 1 + (g.IO.KeyShift ? -1 : 1);
+        else
+            g.FocusRequestNextCounterTabStop = g.IO.KeyShift ? -1 : 0;
+    }
+
+    // Turn queued focus request into current one
+    g.FocusRequestCurrWindow = NULL;
+    g.FocusRequestCurrCounterRegular = g.FocusRequestCurrCounterTabStop = INT_MAX;
+    if (g.FocusRequestNextWindow != NULL)
+    {
+        ImGuiWindow* window = g.FocusRequestNextWindow;
+        g.FocusRequestCurrWindow = window;
+        if (g.FocusRequestNextCounterRegular != INT_MAX && window->DC.FocusCounterRegular != -1)
+            g.FocusRequestCurrCounterRegular = ImModPositive(g.FocusRequestNextCounterRegular, window->DC.FocusCounterRegular + 1);
+        if (g.FocusRequestNextCounterTabStop != INT_MAX && window->DC.FocusCounterTabStop != -1)
+            g.FocusRequestCurrCounterTabStop = ImModPositive(g.FocusRequestNextCounterTabStop, window->DC.FocusCounterTabStop + 1);
+        g.FocusRequestNextWindow = NULL;
+        g.FocusRequestNextCounterRegular = g.FocusRequestNextCounterTabStop = INT_MAX;
+    }
+
+    g.NavIdTabCounter = INT_MAX;
+}
+
+// The reason this is exposed in imgui_internal.h is: on touch-based system that don't have hovering, we want to dispatch inputs to the right target (imgui vs imgui+app)
+void ImGui::UpdateHoveredWindowAndCaptureFlags()
+{
+    ImGuiContext& g = *GImGui;
+
+    // Find the window hovered by mouse:
+    // - Child windows can extend beyond the limit of their parent so we need to derive HoveredRootWindow from HoveredWindow.
+    // - When moving a window we can skip the search, which also conveniently bypasses the fact that window->WindowRectClipped is lagging as this point of the frame.
+    // - We also support the moved window toggling the NoInputs flag after moving has started in order to be able to detect windows below it, which is useful for e.g. docking mechanisms.
+    bool clear_hovered_windows = false;
+    FindHoveredWindow();
+
+    // Modal windows prevents mouse from hovering behind them.
+    ImGuiWindow* modal_window = GetTopMostPopupModal();
+    if (modal_window && g.HoveredRootWindow && !IsWindowChildOf(g.HoveredRootWindow, modal_window))
+        clear_hovered_windows = true;
+
+    // Disabled mouse?
+    if (g.IO.ConfigFlags & ImGuiConfigFlags_NoMouse)
+        clear_hovered_windows = true;
+
+    // We track click ownership. When clicked outside of a window the click is owned by the application and won't report hovering nor request capture even while dragging over our windows afterward.
+    int mouse_earliest_button_down = -1;
+    bool mouse_any_down = false;
+    for (int i = 0; i < IM_ARRAYSIZE(g.IO.MouseDown); i++)
+    {
+        if (g.IO.MouseClicked[i])
+            g.IO.MouseDownOwned[i] = (g.HoveredWindow != NULL) || (g.OpenPopupStack.Size > 0);
+        mouse_any_down |= g.IO.MouseDown[i];
+        if (g.IO.MouseDown[i])
+            if (mouse_earliest_button_down == -1 || g.IO.MouseClickedTime[i] < g.IO.MouseClickedTime[mouse_earliest_button_down])
+                mouse_earliest_button_down = i;
+    }
+    const bool mouse_avail_to_imgui = (mouse_earliest_button_down == -1) || g.IO.MouseDownOwned[mouse_earliest_button_down];
+
+    // If mouse was first clicked outside of ImGui bounds we also cancel out hovering.
+    // FIXME: For patterns of drag and drop across OS windows, we may need to rework/remove this test (first committed 311c0ca9 on 2015/02)
+    const bool mouse_dragging_extern_payload = g.DragDropActive && (g.DragDropSourceFlags & ImGuiDragDropFlags_SourceExtern) != 0;
+    if (!mouse_avail_to_imgui && !mouse_dragging_extern_payload)
+        clear_hovered_windows = true;
+
+    if (clear_hovered_windows)
+        g.HoveredWindow = g.HoveredRootWindow = g.HoveredWindowUnderMovingWindow = NULL;
+
+    // Update io.WantCaptureMouse for the user application (true = dispatch mouse info to imgui, false = dispatch mouse info to Dear ImGui + app)
+    if (g.WantCaptureMouseNextFrame != -1)
+        g.IO.WantCaptureMouse = (g.WantCaptureMouseNextFrame != 0);
+    else
+        g.IO.WantCaptureMouse = (mouse_avail_to_imgui && (g.HoveredWindow != NULL || mouse_any_down)) || (g.OpenPopupStack.Size > 0);
+
+    // Update io.WantCaptureKeyboard for the user application (true = dispatch keyboard info to imgui, false = dispatch keyboard info to Dear ImGui + app)
+    if (g.WantCaptureKeyboardNextFrame != -1)
+        g.IO.WantCaptureKeyboard = (g.WantCaptureKeyboardNextFrame != 0);
+    else
+        g.IO.WantCaptureKeyboard = (g.ActiveId != 0) || (modal_window != NULL);
+    if (g.IO.NavActive && (g.IO.ConfigFlags & ImGuiConfigFlags_NavEnableKeyboard) && !(g.IO.ConfigFlags & ImGuiConfigFlags_NavNoCaptureKeyboard))
+        g.IO.WantCaptureKeyboard = true;
+
+    // Update io.WantTextInput flag, this is to allow systems without a keyboard (e.g. mobile, hand-held) to show a software keyboard if possible
+    g.IO.WantTextInput = (g.WantTextInputNextFrame != -1) ? (g.WantTextInputNextFrame != 0) : false;
+}
+
+ImGuiKeyModFlags ImGui::GetMergedKeyModFlags()
+{
+    ImGuiContext& g = *GImGui;
+    ImGuiKeyModFlags key_mod_flags = ImGuiKeyModFlags_None;
+    if (g.IO.KeyCtrl)   { key_mod_flags |= ImGuiKeyModFlags_Ctrl; }
+    if (g.IO.KeyShift)  { key_mod_flags |= ImGuiKeyModFlags_Shift; }
+    if (g.IO.KeyAlt)    { key_mod_flags |= ImGuiKeyModFlags_Alt; }
+    if (g.IO.KeySuper)  { key_mod_flags |= ImGuiKeyModFlags_Super; }
+    return key_mod_flags;
+}
+
+void ImGui::NewFrame()
+{
+    IM_ASSERT(GImGui != NULL && "No current context. Did you call ImGui::CreateContext() and ImGui::SetCurrentContext() ?");
+    ImGuiContext& g = *GImGui;
+
+#ifdef IMGUI_ENABLE_TEST_ENGINE
+    ImGuiTestEngineHook_PreNewFrame(&g);
 #endif
 
-   if ((g.IO.ConfigFlags & ImGuiConfigFlags_NavEnableGamepad) && (g.IO.BackendFlags & ImGuiBackendFlags_HasGamepad))
-      if (g.IO.NavInputs[ImGuiNavInput_Activate] > 0.0f || g.IO.NavInputs[ImGuiNavInput_Input] > 0.0f || g.IO.NavInputs[ImGuiNavInput_Cancel] > 0.0f || g.IO.NavInputs[ImGuiNavInput_Menu] > 0.0f)
-         g.NavInputSource = ImGuiInputSource_NavGamepad;
-
-   // Update Keyboard->Nav inputs mapping
-   if (g.IO.ConfigFlags & ImGuiConfigFlags_NavEnableKeyboard)
-   {
-#define NAV_MAP_KEY(_KEY, _NAV_INPUT) if (IsKeyDown(g.IO.KeyMap[_KEY])) { g.IO.NavInputs[_NAV_INPUT] = 1.0f; g.NavInputSource = ImGuiInputSource_NavKeyboard; }
-      NAV_MAP_KEY(ImGuiKey_Space, ImGuiNavInput_Activate);
-      NAV_MAP_KEY(ImGuiKey_Enter, ImGuiNavInput_Input);
-      NAV_MAP_KEY(ImGuiKey_Escape, ImGuiNavInput_Cancel);
-      NAV_MAP_KEY(ImGuiKey_LeftArrow, ImGuiNavInput_KeyLeft_);
-      NAV_MAP_KEY(ImGuiKey_RightArrow, ImGuiNavInput_KeyRight_);
-      NAV_MAP_KEY(ImGuiKey_UpArrow, ImGuiNavInput_KeyUp_);
-      NAV_MAP_KEY(ImGuiKey_DownArrow, ImGuiNavInput_KeyDown_);
-      if (g.IO.KeyCtrl)   g.IO.NavInputs[ImGuiNavInput_TweakSlow] = 1.0f;
-      if (g.IO.KeyShift)  g.IO.NavInputs[ImGuiNavInput_TweakFast] = 1.0f;
-      if (g.IO.KeyAlt)    g.IO.NavInputs[ImGuiNavInput_KeyMenu_] = 1.0f;
-#undef NAV_MAP_KEY
-   }
-
-   memcpy(g.IO.NavInputsDownDurationPrev, g.IO.NavInputsDownDuration, sizeof(g.IO.NavInputsDownDuration));
-   for (int i = 0; i < IM_ARRAYSIZE(g.IO.NavInputs); i++)
-      g.IO.NavInputsDownDuration[i] = (g.IO.NavInputs[i] > 0.0f) ? (g.IO.NavInputsDownDuration[i] < 0.0f ? 0.0f : g.IO.NavInputsDownDuration[i] + g.IO.DeltaTime) : -1.0f;
-
-   // Process navigation init request (select first/default focus)
-   if (g.NavInitResultId != 0 && (!g.NavDisableHighlight || g.NavInitRequestFromMove))
-   {
-      // Apply result from previous navigation init request (will typically select the first item, unless SetItemDefaultFocus() has been called)
-      IM_ASSERT(g.NavWindow);
-      if (g.NavInitRequestFromMove)
-         SetNavIDWithRectRel(g.NavInitResultId, g.NavLayer, g.NavInitResultRectRel);
-      else
-         SetNavID(g.NavInitResultId, g.NavLayer);
-      g.NavWindow->NavRectRel[g.NavLayer] = g.NavInitResultRectRel;
-   }
-   g.NavInitRequest = false;
-   g.NavInitRequestFromMove = false;
-   g.NavInitResultId = 0;
-   g.NavJustMovedToId = 0;
-
-   // Process navigation move request
-   if (g.NavMoveRequest && (g.NavMoveResultLocal.ID != 0 || g.NavMoveResultOther.ID != 0))
-   {
-      // Select which result to use
-      ImGuiNavMoveResult* result = (g.NavMoveResultLocal.ID != 0) ? &g.NavMoveResultLocal : &g.NavMoveResultOther;
-      if (g.NavMoveResultOther.ID != 0 && g.NavMoveResultOther.Window->ParentWindow == g.NavWindow) // Maybe entering a flattened child? In this case solve the tie using the regular scoring rules
-         if ((g.NavMoveResultOther.DistBox < g.NavMoveResultLocal.DistBox) || (g.NavMoveResultOther.DistBox == g.NavMoveResultLocal.DistBox && g.NavMoveResultOther.DistCenter < g.NavMoveResultLocal.DistCenter))
-            result = &g.NavMoveResultOther;
-
-      IM_ASSERT(g.NavWindow && result->Window);
-
-      // Scroll to keep newly navigated item fully into view
-      if (g.NavLayer == 0)
-         NavScrollToBringItemIntoView(result->Window, result->RectRel);
-
-      // Apply result from previous frame navigation directional move request
-      ClearActiveID();
-      g.NavWindow = result->Window;
-      SetNavIDWithRectRel(result->ID, g.NavLayer, result->RectRel);
-      g.NavJustMovedToId = result->ID;
-      g.NavMoveFromClampedRefRect = false;
-   }
-
-   // When a forwarded move request failed, we restore the highlight that we disabled during the forward frame
-   if (g.NavMoveRequestForward == ImGuiNavForward_ForwardActive)
-   {
-      IM_ASSERT(g.NavMoveRequest);
-      if (g.NavMoveResultLocal.ID == 0 && g.NavMoveResultOther.ID == 0)
-         g.NavDisableHighlight = false;
-      g.NavMoveRequestForward = ImGuiNavForward_None;
-   }
-
-   // Apply application mouse position movement, after we had a chance to process move request result.
-   if (g.NavMousePosDirty && g.NavIdIsAlive)
-   {
-      // Set mouse position given our knowledge of the navigated item position from last frame
-      if ((g.IO.ConfigFlags & ImGuiConfigFlags_NavEnableSetMousePos) && (g.IO.BackendFlags & ImGuiBackendFlags_HasSetMousePos))
-      {
-         IM_ASSERT(!g.NavDisableHighlight && g.NavDisableMouseHover);
-         g.IO.MousePos = g.IO.MousePosPrev = NavCalcPreferredRefPos();
-         g.IO.WantSetMousePos = true;
-      }
-      g.NavMousePosDirty = false;
-   }
-   g.NavIdIsAlive = false;
-   g.NavJustTabbedId = 0;
-   IM_ASSERT(g.NavLayer == 0 || g.NavLayer == 1);
-
-   // Store our return window (for returning from Layer 1 to Layer 0) and clear it as soon as we step back in our own Layer 0
-   if (g.NavWindow)
-      NavSaveLastChildNavWindow(g.NavWindow);
-   if (g.NavWindow && g.NavWindow->NavLastChildNavWindow != NULL && g.NavLayer == 0)
-      g.NavWindow->NavLastChildNavWindow = NULL;
-
-   NavUpdateWindowing();
-
-   // Set output flags for user application
-   bool nav_keyboard_active = (g.IO.ConfigFlags & ImGuiConfigFlags_NavEnableKeyboard) != 0;
-   bool nav_gamepad_active = (g.IO.ConfigFlags & ImGuiConfigFlags_NavEnableGamepad) != 0 && (g.IO.BackendFlags & ImGuiBackendFlags_HasGamepad) != 0;
-   g.IO.NavActive = (nav_keyboard_active || nav_gamepad_active) && g.NavWindow && !(g.NavWindow->Flags & ImGuiWindowFlags_NoNavInputs);
-   g.IO.NavVisible = (g.IO.NavActive && g.NavId != 0 && !g.NavDisableHighlight) || (g.NavWindowingTarget != NULL) || g.NavInitRequest;
-
-   // Process NavCancel input (to close a popup, get back to parent, clear focus)
-   if (IsNavInputPressed(ImGuiNavInput_Cancel, ImGuiInputReadMode_Pressed))
-   {
-      if (g.ActiveId != 0)
-      {
-         ClearActiveID();
-      }
-      else if (g.NavWindow && (g.NavWindow->Flags & ImGuiWindowFlags_ChildWindow) && !(g.NavWindow->Flags & ImGuiWindowFlags_Popup) && g.NavWindow->ParentWindow)
-      {
-         // Exit child window
-         ImGuiWindow* child_window = g.NavWindow;
-         ImGuiWindow* parent_window = g.NavWindow->ParentWindow;
-         IM_ASSERT(child_window->ChildId != 0);
-         FocusWindow(parent_window);
-         SetNavID(child_window->ChildId, 0);
-         g.NavIdIsAlive = false;
-         if (g.NavDisableMouseHover)
-            g.NavMousePosDirty = true;
-      }
-      else if (g.OpenPopupStack.Size > 0)
-      {
-         // Close open popup/menu
-         if (!(g.OpenPopupStack.back().Window->Flags & ImGuiWindowFlags_Modal))
-            ClosePopupToLevel(g.OpenPopupStack.Size - 1);
-      }
-      else if (g.NavLayer != 0)
-      {
-         // Leave the "menu" layer
-         NavRestoreLayer(0);
-      }
-      else
-      {
-         // Clear NavLastId for popups but keep it for regular child window so we can leave one and come back where we were
-         if (g.NavWindow && ((g.NavWindow->Flags & ImGuiWindowFlags_Popup) || !(g.NavWindow->Flags & ImGuiWindowFlags_ChildWindow)))
-            g.NavWindow->NavLastIds[0] = 0;
-         g.NavId = 0;
-      }
-   }
-
-   // Process manual activation request
-   g.NavActivateId = g.NavActivateDownId = g.NavActivatePressedId = g.NavInputId = 0;
-   if (g.NavId != 0 && !g.NavDisableHighlight && !g.NavWindowingTarget && g.NavWindow && !(g.NavWindow->Flags & ImGuiWindowFlags_NoNavInputs))
-   {
-      bool activate_down = IsNavInputDown(ImGuiNavInput_Activate);
-      bool activate_pressed = activate_down && IsNavInputPressed(ImGuiNavInput_Activate, ImGuiInputReadMode_Pressed);
-      if (g.ActiveId == 0 && activate_pressed)
-         g.NavActivateId = g.NavId;
-      if ((g.ActiveId == 0 || g.ActiveId == g.NavId) && activate_down)
-         g.NavActivateDownId = g.NavId;
-      if ((g.ActiveId == 0 || g.ActiveId == g.NavId) && activate_pressed)
-         g.NavActivatePressedId = g.NavId;
-      if ((g.ActiveId == 0 || g.ActiveId == g.NavId) && IsNavInputPressed(ImGuiNavInput_Input, ImGuiInputReadMode_Pressed))
-         g.NavInputId = g.NavId;
-   }
-   if (g.NavWindow && (g.NavWindow->Flags & ImGuiWindowFlags_NoNavInputs))
-      g.NavDisableHighlight = true;
-   if (g.NavActivateId != 0)
-      IM_ASSERT(g.NavActivateDownId == g.NavActivateId);
-   g.NavMoveRequest = false;
-
-   // Process programmatic activation request
-   if (g.NavNextActivateId != 0)
-      g.NavActivateId = g.NavActivateDownId = g.NavActivatePressedId = g.NavInputId = g.NavNextActivateId;
-   g.NavNextActivateId = 0;
-
-   // Initiate directional inputs request
-   const int allowed_dir_flags = (g.ActiveId == 0) ? ~0 : g.ActiveIdAllowNavDirFlags;
-   if (g.NavMoveRequestForward == ImGuiNavForward_None)
-   {
-      g.NavMoveDir = ImGuiDir_None;
-      if (g.NavWindow && !g.NavWindowingTarget && allowed_dir_flags && !(g.NavWindow->Flags & ImGuiWindowFlags_NoNavInputs))
-      {
-         if ((allowed_dir_flags & (1 << ImGuiDir_Left)) && IsNavInputPressedAnyOfTwo(ImGuiNavInput_DpadLeft, ImGuiNavInput_KeyLeft_, ImGuiInputReadMode_Repeat)) g.NavMoveDir = ImGuiDir_Left;
-         if ((allowed_dir_flags & (1 << ImGuiDir_Right)) && IsNavInputPressedAnyOfTwo(ImGuiNavInput_DpadRight, ImGuiNavInput_KeyRight_, ImGuiInputReadMode_Repeat)) g.NavMoveDir = ImGuiDir_Right;
-         if ((allowed_dir_flags & (1 << ImGuiDir_Up)) && IsNavInputPressedAnyOfTwo(ImGuiNavInput_DpadUp, ImGuiNavInput_KeyUp_, ImGuiInputReadMode_Repeat)) g.NavMoveDir = ImGuiDir_Up;
-         if ((allowed_dir_flags & (1 << ImGuiDir_Down)) && IsNavInputPressedAnyOfTwo(ImGuiNavInput_DpadDown, ImGuiNavInput_KeyDown_, ImGuiInputReadMode_Repeat)) g.NavMoveDir = ImGuiDir_Down;
-      }
-   }
-   else
-   {
-      // Forwarding previous request (which has been modified, e.g. wrap around menus rewrite the requests with a starting rectangle at the other side of the window)
-      IM_ASSERT(g.NavMoveDir != ImGuiDir_None);
-      IM_ASSERT(g.NavMoveRequestForward == ImGuiNavForward_ForwardQueued);
-      g.NavMoveRequestForward = ImGuiNavForward_ForwardActive;
-   }
-
-   if (g.NavMoveDir != ImGuiDir_None)
-   {
-      g.NavMoveRequest = true;
-      g.NavMoveDirLast = g.NavMoveDir;
-   }
-
-   // If we initiate a movement request and have no current NavId, we initiate a InitDefautRequest that will be used as a fallback if the direction fails to find a match
-   if (g.NavMoveRequest && g.NavId == 0)
-   {
-      g.NavInitRequest = g.NavInitRequestFromMove = true;
-      g.NavInitResultId = 0;
-      g.NavDisableHighlight = false;
-   }
-
-   NavUpdateAnyRequestFlag();
-
-   // Scrolling
-   if (g.NavWindow && !(g.NavWindow->Flags & ImGuiWindowFlags_NoNavInputs) && !g.NavWindowingTarget)
-   {
-      // *Fallback* manual-scroll with NavUp/NavDown when window has no navigable item
-      ImGuiWindow* window = g.NavWindow;
-      const float scroll_speed = ImFloor(window->CalcFontSize() * 100 * g.IO.DeltaTime + 0.5f); // We need round the scrolling speed because sub-pixel scroll isn't reliably supported.
-      if (window->DC.NavLayerActiveMask == 0x00 && window->DC.NavHasScroll && g.NavMoveRequest)
-      {
-         if (g.NavMoveDir == ImGuiDir_Left || g.NavMoveDir == ImGuiDir_Right)
-            SetWindowScrollX(window, ImFloor(window->Scroll.x + ((g.NavMoveDir == ImGuiDir_Left) ? -1.0f : +1.0f) * scroll_speed));
-         if (g.NavMoveDir == ImGuiDir_Up || g.NavMoveDir == ImGuiDir_Down)
-            SetWindowScrollY(window, ImFloor(window->Scroll.y + ((g.NavMoveDir == ImGuiDir_Up) ? -1.0f : +1.0f) * scroll_speed));
-      }
-
-      // *Normal* Manual scroll with NavScrollXXX keys
-      // Next movement request will clamp the NavId reference rectangle to the visible area, so navigation will resume within those bounds.
-      ImVec2 scroll_dir = GetNavInputAmount2d(ImGuiNavDirSourceFlags_PadLStick, ImGuiInputReadMode_Down, 1.0f / 10.0f, 10.0f);
-      if (scroll_dir.x != 0.0f && window->ScrollbarX)
-      {
-         SetWindowScrollX(window, ImFloor(window->Scroll.x + scroll_dir.x * scroll_speed));
-         g.NavMoveFromClampedRefRect = true;
-      }
-      if (scroll_dir.y != 0.0f)
-      {
-         SetWindowScrollY(window, ImFloor(window->Scroll.y + scroll_dir.y * scroll_speed));
-         g.NavMoveFromClampedRefRect = true;
-      }
-   }
-
-   // Reset search results
-   g.NavMoveResultLocal.Clear();
-   g.NavMoveResultOther.Clear();
-
-   // When we have manually scrolled (without using navigation) and NavId becomes out of bounds, we project its bounding box to the visible area to restart navigation within visible items
-   if (g.NavMoveRequest && g.NavMoveFromClampedRefRect && g.NavLayer == 0)
-   {
-      ImGuiWindow* window = g.NavWindow;
-      ImRect window_rect_rel(window->InnerRect.Min - window->Pos - ImVec2(1, 1), window->InnerRect.Max - window->Pos + ImVec2(1, 1));
-      if (!window_rect_rel.Contains(window->NavRectRel[g.NavLayer]))
-      {
-         float pad = window->CalcFontSize() * 0.5f;
-         window_rect_rel.Expand(ImVec2(-ImMin(window_rect_rel.GetWidth(), pad), -ImMin(window_rect_rel.GetHeight(), pad))); // Terrible approximation for the intent of starting navigation from first fully visible item
-         window->NavRectRel[g.NavLayer].ClipWith(window_rect_rel);
-         g.NavId = 0;
-      }
-      g.NavMoveFromClampedRefRect = false;
-   }
-
-   // For scoring we use a single segment on the left side our current item bounding box (not touching the edge to avoid box overlap with zero-spaced items)
-   ImRect nav_rect_rel = (g.NavWindow && !g.NavWindow->NavRectRel[g.NavLayer].IsInverted()) ? g.NavWindow->NavRectRel[g.NavLayer] : ImRect(0, 0, 0, 0);
-   g.NavScoringRectScreen = g.NavWindow ? ImRect(g.NavWindow->Pos + nav_rect_rel.Min, g.NavWindow->Pos + nav_rect_rel.Max) : GetViewportRect();
-   g.NavScoringRectScreen.Min.x = ImMin(g.NavScoringRectScreen.Min.x + 1.0f, g.NavScoringRectScreen.Max.x);
-   g.NavScoringRectScreen.Max.x = g.NavScoringRectScreen.Min.x;
-   IM_ASSERT(!g.NavScoringRectScreen.IsInverted()); // Ensure if we have a finite, non-inverted bounding box here will allows us to remove extraneous fabsf() calls in NavScoreItem().
-                                                    //g.OverlayDrawList.AddRect(g.NavScoringRectScreen.Min, g.NavScoringRectScreen.Max, IM_COL32(255,200,0,255)); // [DEBUG]
-   g.NavScoringCount = 0;
-#if IMGUI_DEBUG_NAV_RECTS
-   if (g.NavWindow) { for (int layer = 0; layer < 2; layer++) GetOverlayDrawList()->AddRect(g.NavWindow->Pos + g.NavWindow->NavRectRel[layer].Min, g.NavWindow->Pos + g.NavWindow->NavRectRel[layer].Max, IM_COL32(255, 200, 0, 255)); } // [DEBUG] 
-   if (g.NavWindow) { ImU32 col = (g.NavWindow->HiddenFrames == 0) ? IM_COL32(255, 0, 255, 255) : IM_COL32(255, 0, 0, 255); ImVec2 p = NavCalcPreferredMousePos(); char buf[32]; ImFormatString(buf, 32, "%d", g.NavLayer); g.OverlayDrawList.AddCircleFilled(p, 3.0f, col); g.OverlayDrawList.AddText(NULL, 13.0f, p + ImVec2(8, -4), col, buf); }
+    // Check and assert for various common IO and Configuration mistakes
+    ErrorCheckNewFrameSanityChecks();
+
+    // Load settings on first frame, save settings when modified (after a delay)
+    UpdateSettings();
+
+    g.Time += g.IO.DeltaTime;
+    g.WithinFrameScope = true;
+    g.FrameCount += 1;
+    g.TooltipOverrideCount = 0;
+    g.WindowsActiveCount = 0;
+    g.MenusIdSubmittedThisFrame.resize(0);
+
+    // Calculate frame-rate for the user, as a purely luxurious feature
+    g.FramerateSecPerFrameAccum += g.IO.DeltaTime - g.FramerateSecPerFrame[g.FramerateSecPerFrameIdx];
+    g.FramerateSecPerFrame[g.FramerateSecPerFrameIdx] = g.IO.DeltaTime;
+    g.FramerateSecPerFrameIdx = (g.FramerateSecPerFrameIdx + 1) % IM_ARRAYSIZE(g.FramerateSecPerFrame);
+    g.IO.Framerate = (g.FramerateSecPerFrameAccum > 0.0f) ? (1.0f / (g.FramerateSecPerFrameAccum / (float)IM_ARRAYSIZE(g.FramerateSecPerFrame))) : FLT_MAX;
+
+    // Setup current font and draw list shared data
+    g.IO.Fonts->Locked = true;
+    SetCurrentFont(GetDefaultFont());
+    IM_ASSERT(g.Font->IsLoaded());
+    g.DrawListSharedData.ClipRectFullscreen = ImVec4(0.0f, 0.0f, g.IO.DisplaySize.x, g.IO.DisplaySize.y);
+    g.DrawListSharedData.CurveTessellationTol = g.Style.CurveTessellationTol;
+    g.DrawListSharedData.SetCircleSegmentMaxError(g.Style.CircleSegmentMaxError);
+    g.DrawListSharedData.InitialFlags = ImDrawListFlags_None;
+    if (g.Style.AntiAliasedLines)
+        g.DrawListSharedData.InitialFlags |= ImDrawListFlags_AntiAliasedLines;
+    if (g.Style.AntiAliasedLinesUseTex && !(g.Font->ContainerAtlas->Flags & ImFontAtlasFlags_NoBakedLines))
+        g.DrawListSharedData.InitialFlags |= ImDrawListFlags_AntiAliasedLinesUseTex;
+    if (g.Style.AntiAliasedFill)
+        g.DrawListSharedData.InitialFlags |= ImDrawListFlags_AntiAliasedFill;
+    if (g.IO.BackendFlags & ImGuiBackendFlags_RendererHasVtxOffset)
+        g.DrawListSharedData.InitialFlags |= ImDrawListFlags_AllowVtxOffset;
+
+    g.BackgroundDrawList._ResetForNewFrame();
+    g.BackgroundDrawList.PushTextureID(g.IO.Fonts->TexID);
+    g.BackgroundDrawList.PushClipRectFullScreen();
+
+    g.ForegroundDrawList._ResetForNewFrame();
+    g.ForegroundDrawList.PushTextureID(g.IO.Fonts->TexID);
+    g.ForegroundDrawList.PushClipRectFullScreen();
+
+    // Mark rendering data as invalid to prevent user who may have a handle on it to use it.
+    g.DrawData.Clear();
+
+    // Drag and drop keep the source ID alive so even if the source disappear our state is consistent
+    if (g.DragDropActive && g.DragDropPayload.SourceId == g.ActiveId)
+        KeepAliveID(g.DragDropPayload.SourceId);
+
+    // Update HoveredId data
+    if (!g.HoveredIdPreviousFrame)
+        g.HoveredIdTimer = 0.0f;
+    if (!g.HoveredIdPreviousFrame || (g.HoveredId && g.ActiveId == g.HoveredId))
+        g.HoveredIdNotActiveTimer = 0.0f;
+    if (g.HoveredId)
+        g.HoveredIdTimer += g.IO.DeltaTime;
+    if (g.HoveredId && g.ActiveId != g.HoveredId)
+        g.HoveredIdNotActiveTimer += g.IO.DeltaTime;
+    g.HoveredIdPreviousFrame = g.HoveredId;
+    g.HoveredId = 0;
+    g.HoveredIdAllowOverlap = false;
+    g.HoveredIdDisabled = false;
+
+    // Update ActiveId data (clear reference to active widget if the widget isn't alive anymore)
+    if (g.ActiveIdIsAlive != g.ActiveId && g.ActiveIdPreviousFrame == g.ActiveId && g.ActiveId != 0)
+        ClearActiveID();
+    if (g.ActiveId)
+        g.ActiveIdTimer += g.IO.DeltaTime;
+    g.LastActiveIdTimer += g.IO.DeltaTime;
+    g.ActiveIdPreviousFrame = g.ActiveId;
+    g.ActiveIdPreviousFrameWindow = g.ActiveIdWindow;
+    g.ActiveIdPreviousFrameHasBeenEditedBefore = g.ActiveIdHasBeenEditedBefore;
+    g.ActiveIdIsAlive = 0;
+    g.ActiveIdHasBeenEditedThisFrame = false;
+    g.ActiveIdPreviousFrameIsAlive = false;
+    g.ActiveIdIsJustActivated = false;
+    if (g.TempInputId != 0 && g.ActiveId != g.TempInputId)
+        g.TempInputId = 0;
+    if (g.ActiveId == 0)
+    {
+        g.ActiveIdUsingNavDirMask = 0x00;
+        g.ActiveIdUsingNavInputMask = 0x00;
+        g.ActiveIdUsingKeyInputMask = 0x00;
+    }
+
+    // Drag and drop
+    g.DragDropAcceptIdPrev = g.DragDropAcceptIdCurr;
+    g.DragDropAcceptIdCurr = 0;
+    g.DragDropAcceptIdCurrRectSurface = FLT_MAX;
+    g.DragDropWithinSource = false;
+    g.DragDropWithinTarget = false;
+    g.DragDropHoldJustPressedId = 0;
+
+    // Update keyboard input state
+    // Synchronize io.KeyMods with individual modifiers io.KeyXXX bools
+    g.IO.KeyMods = GetMergedKeyModFlags();
+    memcpy(g.IO.KeysDownDurationPrev, g.IO.KeysDownDuration, sizeof(g.IO.KeysDownDuration));
+    for (int i = 0; i < IM_ARRAYSIZE(g.IO.KeysDown); i++)
+        g.IO.KeysDownDuration[i] = g.IO.KeysDown[i] ? (g.IO.KeysDownDuration[i] < 0.0f ? 0.0f : g.IO.KeysDownDuration[i] + g.IO.DeltaTime) : -1.0f;
+
+    // Update gamepad/keyboard navigation
+    NavUpdate();
+
+    // Update mouse input state
+    UpdateMouseInputs();
+
+    // Find hovered window
+    // (needs to be before UpdateMouseMovingWindowNewFrame so we fill g.HoveredWindowUnderMovingWindow on the mouse release frame)
+    UpdateHoveredWindowAndCaptureFlags();
+
+    // Handle user moving window with mouse (at the beginning of the frame to avoid input lag or sheering)
+    UpdateMouseMovingWindowNewFrame();
+
+    // Background darkening/whitening
+    if (GetTopMostPopupModal() != NULL || (g.NavWindowingTarget != NULL && g.NavWindowingHighlightAlpha > 0.0f))
+        g.DimBgRatio = ImMin(g.DimBgRatio + g.IO.DeltaTime * 6.0f, 1.0f);
+    else
+        g.DimBgRatio = ImMax(g.DimBgRatio - g.IO.DeltaTime * 10.0f, 0.0f);
+
+    g.MouseCursor = ImGuiMouseCursor_Arrow;
+    g.WantCaptureMouseNextFrame = g.WantCaptureKeyboardNextFrame = g.WantTextInputNextFrame = -1;
+    g.PlatformImePos = ImVec2(1.0f, 1.0f); // OS Input Method Editor showing on top-left of our window by default
+
+    // Mouse wheel scrolling, scale
+    UpdateMouseWheel();
+
+    // Update legacy TAB focus
+    UpdateTabFocus();
+
+    // Mark all windows as not visible and compact unused memory.
+    IM_ASSERT(g.WindowsFocusOrder.Size == g.Windows.Size);
+    const float memory_compact_start_time = (g.IO.ConfigWindowsMemoryCompactTimer >= 0.0f) ? (float)g.Time - g.IO.ConfigWindowsMemoryCompactTimer : FLT_MAX;
+    for (int i = 0; i != g.Windows.Size; i++)
+    {
+        ImGuiWindow* window = g.Windows[i];
+        window->WasActive = window->Active;
+        window->BeginCount = 0;
+        window->Active = false;
+        window->WriteAccessed = false;
+
+        // Garbage collect transient buffers of recently unused windows
+        if (!window->WasActive && !window->MemoryCompacted && window->LastTimeActive < memory_compact_start_time)
+            GcCompactTransientWindowBuffers(window);
+    }
+
+    // Closing the focused window restore focus to the first active root window in descending z-order
+    if (g.NavWindow && !g.NavWindow->WasActive)
+        FocusTopMostWindowUnderOne(NULL, NULL);
+
+    // No window should be open at the beginning of the frame.
+    // But in order to allow the user to call NewFrame() multiple times without calling Render(), we are doing an explicit clear.
+    g.CurrentWindowStack.resize(0);
+    g.BeginPopupStack.resize(0);
+    ClosePopupsOverWindow(g.NavWindow, false);
+
+    // [DEBUG] Item picker tool - start with DebugStartItemPicker() - useful to visually select an item and break into its call-stack.
+    UpdateDebugToolItemPicker();
+
+    // Create implicit/fallback window - which we will only render it if the user has added something to it.
+    // We don't use "Debug" to avoid colliding with user trying to create a "Debug" window with custom flags.
+    // This fallback is particularly important as it avoid ImGui:: calls from crashing.
+    g.WithinFrameScopeWithImplicitWindow = true;
+    SetNextWindowSize(ImVec2(400, 400), ImGuiCond_FirstUseEver);
+    Begin("Debug##Default");
+    IM_ASSERT(g.CurrentWindow->IsFallbackWindow == true);
+
+#ifdef IMGUI_ENABLE_TEST_ENGINE
+    ImGuiTestEngineHook_PostNewFrame(&g);
 #endif
 }
 
-static void ImGui::UpdateMovingWindow()
-{
-   ImGuiContext& g = *GImGui;
-   if (g.MovingWindow != NULL)
-   {
-      // We actually want to move the root window. g.MovingWindow == window we clicked on (could be a child window). 
-      // We track it to preserve Focus and so that generally ActiveIdWindow == MovingWindow and ActiveId == MovingWindow->MoveId for consistency.
-      KeepAliveID(g.ActiveId);
-      IM_ASSERT(g.MovingWindow && g.MovingWindow->RootWindow);
-      ImGuiWindow* moving_window = g.MovingWindow->RootWindow;
-      if (g.IO.MouseDown[0] && IsMousePosValid(&g.IO.MousePos))
-      {
-         ImVec2 pos = g.IO.MousePos - g.ActiveIdClickOffset;
-         if (moving_window->Pos.x != pos.x || moving_window->Pos.y != pos.y)
-         {
-            MarkIniSettingsDirty(moving_window);
-            SetWindowPos(moving_window, pos, ImGuiCond_Always);
-         }
-         FocusWindow(g.MovingWindow);
-      }
-      else
-      {
-         ClearActiveID();
-         g.MovingWindow = NULL;
-      }
-   }
-   else
-   {
-      // When clicking/dragging from a window that has the _NoMove flag, we still set the ActiveId in order to prevent hovering others.
-      if (g.ActiveIdWindow && g.ActiveIdWindow->MoveId == g.ActiveId)
-      {
-         KeepAliveID(g.ActiveId);
-         if (!g.IO.MouseDown[0])
-            ClearActiveID();
-      }
-   }
-}
-
-static void ImGui::UpdateMouseInputs()
-{
-   ImGuiContext& g = *GImGui;
-
-   // If mouse just appeared or disappeared (usually denoted by -FLT_MAX component, but in reality we test for -256000.0f) we cancel out movement in MouseDelta
-   if (IsMousePosValid(&g.IO.MousePos) && IsMousePosValid(&g.IO.MousePosPrev))
-      g.IO.MouseDelta = g.IO.MousePos - g.IO.MousePosPrev;
-   else
-      g.IO.MouseDelta = ImVec2(0.0f, 0.0f);
-   if (g.IO.MouseDelta.x != 0.0f || g.IO.MouseDelta.y != 0.0f)
-      g.NavDisableMouseHover = false;
-
-   g.IO.MousePosPrev = g.IO.MousePos;
-   for (int i = 0; i < IM_ARRAYSIZE(g.IO.MouseDown); i++)
-   {
-      g.IO.MouseClicked[i] = g.IO.MouseDown[i] && g.IO.MouseDownDuration[i] < 0.0f;
-      g.IO.MouseReleased[i] = !g.IO.MouseDown[i] && g.IO.MouseDownDuration[i] >= 0.0f;
-      g.IO.MouseDownDurationPrev[i] = g.IO.MouseDownDuration[i];
-      g.IO.MouseDownDuration[i] = g.IO.MouseDown[i] ? (g.IO.MouseDownDuration[i] < 0.0f ? 0.0f : g.IO.MouseDownDuration[i] + g.IO.DeltaTime) : -1.0f;
-      g.IO.MouseDoubleClicked[i] = false;
-      if (g.IO.MouseClicked[i])
-      {
-         if (g.Time - g.IO.MouseClickedTime[i] < g.IO.MouseDoubleClickTime)
-         {
-            if (ImLengthSqr(g.IO.MousePos - g.IO.MouseClickedPos[i]) < g.IO.MouseDoubleClickMaxDist * g.IO.MouseDoubleClickMaxDist)
-               g.IO.MouseDoubleClicked[i] = true;
-            g.IO.MouseClickedTime[i] = -FLT_MAX;    // so the third click isn't turned into a double-click
-         }
-         else
-         {
-            g.IO.MouseClickedTime[i] = g.Time;
-         }
-         g.IO.MouseClickedPos[i] = g.IO.MousePos;
-         g.IO.MouseDragMaxDistanceAbs[i] = ImVec2(0.0f, 0.0f);
-         g.IO.MouseDragMaxDistanceSqr[i] = 0.0f;
-      }
-      else if (g.IO.MouseDown[i])
-      {
-         ImVec2 mouse_delta = g.IO.MousePos - g.IO.MouseClickedPos[i];
-         g.IO.MouseDragMaxDistanceAbs[i].x = ImMax(g.IO.MouseDragMaxDistanceAbs[i].x, mouse_delta.x < 0.0f ? -mouse_delta.x : mouse_delta.x);
-         g.IO.MouseDragMaxDistanceAbs[i].y = ImMax(g.IO.MouseDragMaxDistanceAbs[i].y, mouse_delta.y < 0.0f ? -mouse_delta.y : mouse_delta.y);
-         g.IO.MouseDragMaxDistanceSqr[i] = ImMax(g.IO.MouseDragMaxDistanceSqr[i], ImLengthSqr(mouse_delta));
-      }
-      if (g.IO.MouseClicked[i]) // Clicking any mouse button reactivate mouse hovering which may have been deactivated by gamepad/keyboard navigation
-         g.NavDisableMouseHover = false;
-   }
-}
-
-// The reason this is exposed in imgui_internal.h is: on touch-based system that don't have hovering, we want to dispatch inputs to the right target (imgui vs imgui+app)
-void ImGui::NewFrameUpdateHoveredWindowAndCaptureFlags()
-{
-   ImGuiContext& g = *GImGui;
-
-   // Find the window hovered by mouse:
-   // - Child windows can extend beyond the limit of their parent so we need to derive HoveredRootWindow from HoveredWindow.
-   // - When moving a window we can skip the search, which also conveniently bypasses the fact that window->WindowRectClipped is lagging as this point of the frame.
-   // - We also support the moved window toggling the NoInputs flag after moving has started in order to be able to detect windows below it, which is useful for e.g. docking mechanisms.
-   g.HoveredWindow = (g.MovingWindow && !(g.MovingWindow->Flags & ImGuiWindowFlags_NoInputs)) ? g.MovingWindow : FindHoveredWindow();
-   g.HoveredRootWindow = g.HoveredWindow ? g.HoveredWindow->RootWindow : NULL;
-
-   // Modal windows prevents cursor from hovering behind them.
-   ImGuiWindow* modal_window = GetFrontMostPopupModal();
-   if (modal_window)
-      if (g.HoveredRootWindow && !IsWindowChildOf(g.HoveredRootWindow, modal_window))
-         g.HoveredRootWindow = g.HoveredWindow = NULL;
-
-   // Disabled mouse?
-   if (g.IO.ConfigFlags & ImGuiConfigFlags_NoMouse)
-      g.HoveredWindow = g.HoveredRootWindow = NULL;
-
-   // We track click ownership. When clicked outside of a window the click is owned by the application and won't report hovering nor request capture even while dragging over our windows afterward.
-   int mouse_earliest_button_down = -1;
-   bool mouse_any_down = false;
-   for (int i = 0; i < IM_ARRAYSIZE(g.IO.MouseDown); i++)
-   {
-      if (g.IO.MouseClicked[i])
-         g.IO.MouseDownOwned[i] = (g.HoveredWindow != NULL) || (!g.OpenPopupStack.empty());
-      mouse_any_down |= g.IO.MouseDown[i];
-      if (g.IO.MouseDown[i])
-         if (mouse_earliest_button_down == -1 || g.IO.MouseClickedTime[i] < g.IO.MouseClickedTime[mouse_earliest_button_down])
-            mouse_earliest_button_down = i;
-   }
-   const bool mouse_avail_to_imgui = (mouse_earliest_button_down == -1) || g.IO.MouseDownOwned[mouse_earliest_button_down];
-
-   // If mouse was first clicked outside of ImGui bounds we also cancel out hovering.
-   // FIXME: For patterns of drag and drop across OS windows, we may need to rework/remove this test (first committed 311c0ca9 on 2015/02)
-   const bool mouse_dragging_extern_payload = g.DragDropActive && (g.DragDropSourceFlags & ImGuiDragDropFlags_SourceExtern) != 0;
-   if (!mouse_avail_to_imgui && !mouse_dragging_extern_payload)
-      g.HoveredWindow = g.HoveredRootWindow = NULL;
-
-   // Update io.WantCaptureMouse for the user application (true = dispatch mouse info to imgui, false = dispatch mouse info to imgui + app)
-   if (g.WantCaptureMouseNextFrame != -1)
-      g.IO.WantCaptureMouse = (g.WantCaptureMouseNextFrame != 0);
-   else
-      g.IO.WantCaptureMouse = (mouse_avail_to_imgui && (g.HoveredWindow != NULL || mouse_any_down)) || (!g.OpenPopupStack.empty());
-
-   // Update io.WantCaptureKeyboard for the user application (true = dispatch keyboard info to imgui, false = dispatch keyboard info to imgui + app)
-   if (g.WantCaptureKeyboardNextFrame != -1)
-      g.IO.WantCaptureKeyboard = (g.WantCaptureKeyboardNextFrame != 0);
-   else
-      g.IO.WantCaptureKeyboard = (g.ActiveId != 0) || (modal_window != NULL);
-   if (g.IO.NavActive && (g.IO.ConfigFlags & ImGuiConfigFlags_NavEnableKeyboard) && !(g.IO.ConfigFlags & ImGuiConfigFlags_NavNoCaptureKeyboard))
-      g.IO.WantCaptureKeyboard = true;
-
-   // Update io.WantTextInput flag, this is to allow systems without a keyboard (e.g. mobile, hand-held) to show a software keyboard if possible
-   g.IO.WantTextInput = (g.WantTextInputNextFrame != -1) ? (g.WantTextInputNextFrame != 0) : false;
-}
-
-void ImGui::NewFrame()
-{
-   IM_ASSERT(GImGui != NULL && "No current context. Did you call ImGui::CreateContext() or ImGui::SetCurrentContext()?");
-   ImGuiContext& g = *GImGui;
-
-   // Check user data
-   // (We pass an error message in the assert expression to make it visible to programmers who are not using a debugger, as most assert handlers display their argument)
-   IM_ASSERT(g.Initialized);
-   IM_ASSERT(g.IO.DeltaTime >= 0.0f                                    && "Need a positive DeltaTime (zero is tolerated but will cause some timing issues)");
-   IM_ASSERT(g.IO.DisplaySize.x >= 0.0f && g.IO.DisplaySize.y >= 0.0f  && "Invalid DisplaySize value");
-   IM_ASSERT(g.IO.Fonts->Fonts.Size > 0 && "Font Atlas not built. Did you call io.Fonts->GetTexDataAsRGBA32() / GetTexDataAsAlpha8() ?");
-   IM_ASSERT(g.IO.Fonts->Fonts[0]->IsLoaded() && "Font Atlas not built. Did you call io.Fonts->GetTexDataAsRGBA32() / GetTexDataAsAlpha8() ?");
-   IM_ASSERT(g.Style.CurveTessellationTol > 0.0f                       && "Invalid style setting");
-   IM_ASSERT(g.Style.Alpha >= 0.0f && g.Style.Alpha <= 1.0f            && "Invalid style setting. Alpha cannot be negative (allows us to avoid a few clamps in color computations)");
-   IM_ASSERT((g.FrameCount == 0 || g.FrameCountEnded == g.FrameCount) && "Forgot to call Render() or EndFrame() at the end of the previous frame?");
-   for (int n = 0; n < ImGuiKey_COUNT; n++)
-      IM_ASSERT(g.IO.KeyMap[n] >= -1 && g.IO.KeyMap[n] < IM_ARRAYSIZE(g.IO.KeysDown) && "io.KeyMap[] contains an out of bound value (need to be 0..512, or -1 for unmapped key)");
-
-   // Perform simple check for required key mapping (we intentionally do NOT check all keys to not pressure user into setting up everything, but Space is required and was only recently added in 1.60 WIP)
-   if (g.IO.ConfigFlags & ImGuiConfigFlags_NavEnableKeyboard)
-      IM_ASSERT(g.IO.KeyMap[ImGuiKey_Space] != -1 && "ImGuiKey_Space is not mapped, required for keyboard navigation.");
-
-   // Load settings on first frame
-   if (!g.SettingsLoaded)
-   {
-      IM_ASSERT(g.SettingsWindows.empty());
-      LoadIniSettingsFromDisk(g.IO.IniFilename);
-      g.SettingsLoaded = true;
-   }
-
-   // Save settings (with a delay so we don't spam disk too much)
-   if (g.SettingsDirtyTimer > 0.0f)
-   {
-      g.SettingsDirtyTimer -= g.IO.DeltaTime;
-      if (g.SettingsDirtyTimer <= 0.0f)
-         SaveIniSettingsToDisk(g.IO.IniFilename);
-   }
-
-   g.Time += g.IO.DeltaTime;
-   g.FrameCount += 1;
-   g.TooltipOverrideCount = 0;
-   g.WindowsActiveCount = 0;
-
-   SetCurrentFont(GetDefaultFont());
-   IM_ASSERT(g.Font->IsLoaded());
-   g.DrawListSharedData.ClipRectFullscreen = ImVec4(0.0f, 0.0f, g.IO.DisplaySize.x, g.IO.DisplaySize.y);
-   g.DrawListSharedData.CurveTessellationTol = g.Style.CurveTessellationTol;
-
-   g.OverlayDrawList.Clear();
-   g.OverlayDrawList.PushTextureID(g.IO.Fonts->TexID);
-   g.OverlayDrawList.PushClipRectFullScreen();
-   g.OverlayDrawList.Flags = (g.Style.AntiAliasedLines ? ImDrawListFlags_AntiAliasedLines : 0) | (g.Style.AntiAliasedFill ? ImDrawListFlags_AntiAliasedFill : 0);
-
-   // Mark rendering data as invalid to prevent user who may have a handle on it to use it
-   g.DrawData.Clear();
-
-   // Clear reference to active widget if the widget isn't alive anymore
-   if (!g.HoveredIdPreviousFrame)
-      g.HoveredIdTimer = 0.0f;
-   g.HoveredIdPreviousFrame = g.HoveredId;
-   g.HoveredId = 0;
-   g.HoveredIdAllowOverlap = false;
-   if (!g.ActiveIdIsAlive && g.ActiveIdPreviousFrame == g.ActiveId && g.ActiveId != 0)
-      ClearActiveID();
-   if (g.ActiveId)
-      g.ActiveIdTimer += g.IO.DeltaTime;
-   g.ActiveIdPreviousFrame = g.ActiveId;
-   g.ActiveIdIsAlive = false;
-   g.ActiveIdIsJustActivated = false;
-   if (g.ScalarAsInputTextId && g.ActiveId != g.ScalarAsInputTextId)
-      g.ScalarAsInputTextId = 0;
-
-   // Elapse drag & drop payload
-   if (g.DragDropActive && g.DragDropPayload.DataFrameCount + 1 < g.FrameCount)
-   {
-      ClearDragDrop();
-      g.DragDropPayloadBufHeap.clear();
-      memset(&g.DragDropPayloadBufLocal, 0, sizeof(g.DragDropPayloadBufLocal));
-   }
-   g.DragDropAcceptIdPrev = g.DragDropAcceptIdCurr;
-   g.DragDropAcceptIdCurr = 0;
-   g.DragDropAcceptIdCurrRectSurface = FLT_MAX;
-
-   // Update keyboard input state
-   memcpy(g.IO.KeysDownDurationPrev, g.IO.KeysDownDuration, sizeof(g.IO.KeysDownDuration));
-   for (int i = 0; i < IM_ARRAYSIZE(g.IO.KeysDown); i++)
-      g.IO.KeysDownDuration[i] = g.IO.KeysDown[i] ? (g.IO.KeysDownDuration[i] < 0.0f ? 0.0f : g.IO.KeysDownDuration[i] + g.IO.DeltaTime) : -1.0f;
-
-   // Update gamepad/keyboard directional navigation
-   NavUpdate();
-
-   // Update mouse input state
-   UpdateMouseInputs();
-
-   // Calculate frame-rate for the user, as a purely luxurious feature
-   g.FramerateSecPerFrameAccum += g.IO.DeltaTime - g.FramerateSecPerFrame[g.FramerateSecPerFrameIdx];
-   g.FramerateSecPerFrame[g.FramerateSecPerFrameIdx] = g.IO.DeltaTime;
-   g.FramerateSecPerFrameIdx = (g.FramerateSecPerFrameIdx + 1) % IM_ARRAYSIZE(g.FramerateSecPerFrame);
-   g.IO.Framerate = (g.FramerateSecPerFrameAccum > 0.0f) ? (1.0f / (g.FramerateSecPerFrameAccum / (float)IM_ARRAYSIZE(g.FramerateSecPerFrame))) : FLT_MAX;
-
-   // Handle user moving window with mouse (at the beginning of the frame to avoid input lag or sheering)
-   UpdateMovingWindow();
-   NewFrameUpdateHoveredWindowAndCaptureFlags();
-
-   if (GetFrontMostPopupModal() != NULL)
-      g.ModalWindowDarkeningRatio = ImMin(g.ModalWindowDarkeningRatio + g.IO.DeltaTime * 6.0f, 1.0f);
-   else
-      g.ModalWindowDarkeningRatio = 0.0f;
-
-   g.MouseCursor = ImGuiMouseCursor_Arrow;
-   g.WantCaptureMouseNextFrame = g.WantCaptureKeyboardNextFrame = g.WantTextInputNextFrame = -1;
-   g.PlatformImePos = ImVec2(1.0f, 1.0f); // OS Input Method Editor showing on top-left of our window by default
-
-                                          // Mouse wheel scrolling, scale
-   if (g.HoveredWindow && !g.HoveredWindow->Collapsed && (g.IO.MouseWheel != 0.0f || g.IO.MouseWheelH != 0.0f))
-   {
-      // If a child window has the ImGuiWindowFlags_NoScrollWithMouse flag, we give a chance to scroll its parent (unless either ImGuiWindowFlags_NoInputs or ImGuiWindowFlags_NoScrollbar are also set).
-      ImGuiWindow* window = g.HoveredWindow;
-      ImGuiWindow* scroll_window = window;
-      while ((scroll_window->Flags & ImGuiWindowFlags_ChildWindow) && (scroll_window->Flags & ImGuiWindowFlags_NoScrollWithMouse) && !(scroll_window->Flags & ImGuiWindowFlags_NoScrollbar) && !(scroll_window->Flags & ImGuiWindowFlags_NoInputs) && scroll_window->ParentWindow)
-         scroll_window = scroll_window->ParentWindow;
-      const bool scroll_allowed = !(scroll_window->Flags & ImGuiWindowFlags_NoScrollWithMouse) && !(scroll_window->Flags & ImGuiWindowFlags_NoInputs);
-
-      if (g.IO.MouseWheel != 0.0f)
-      {
-         if (g.IO.KeyCtrl && g.IO.FontAllowUserScaling)
-         {
-            // Zoom / Scale window
-            const float new_font_scale = ImClamp(window->FontWindowScale + g.IO.MouseWheel * 0.10f, 0.50f, 2.50f);
-            const float scale = new_font_scale / window->FontWindowScale;
-            window->FontWindowScale = new_font_scale;
-
-            const ImVec2 offset = window->Size * (1.0f - scale) * (g.IO.MousePos - window->Pos) / window->Size;
-            window->Pos += offset;
-            window->Size *= scale;
-            window->SizeFull *= scale;
-         }
-         else if (!g.IO.KeyCtrl && scroll_allowed)
-         {
-            // Mouse wheel vertical scrolling
-            float scroll_amount = 5 * scroll_window->CalcFontSize();
-            scroll_amount = (float)(int)ImMin(scroll_amount, (scroll_window->ContentsRegionRect.GetHeight() + scroll_window->WindowPadding.y * 2.0f) * 0.67f);
-            SetWindowScrollY(scroll_window, scroll_window->Scroll.y - g.IO.MouseWheel * scroll_amount);
-         }
-      }
-      if (g.IO.MouseWheelH != 0.0f && scroll_allowed)
-      {
-         // Mouse wheel horizontal scrolling (for hardware that supports it)
-         float scroll_amount = scroll_window->CalcFontSize();
-         if (!g.IO.KeyCtrl && !(window->Flags & ImGuiWindowFlags_NoScrollWithMouse))
-            SetWindowScrollX(window, window->Scroll.x - g.IO.MouseWheelH * scroll_amount);
-      }
-   }
-
-   // Pressing TAB activate widget focus
-   if (g.ActiveId == 0 && g.NavWindow != NULL && g.NavWindow->Active && !(g.NavWindow->Flags & ImGuiWindowFlags_NoNavInputs) && !g.IO.KeyCtrl && IsKeyPressedMap(ImGuiKey_Tab, false))
-   {
-      if (g.NavId != 0 && g.NavIdTabCounter != INT_MAX)
-         g.NavWindow->FocusIdxTabRequestNext = g.NavIdTabCounter + 1 + (g.IO.KeyShift ? -1 : 1);
-      else
-         g.NavWindow->FocusIdxTabRequestNext = g.IO.KeyShift ? -1 : 0;
-   }
-   g.NavIdTabCounter = INT_MAX;
-
-   // Mark all windows as not visible
-   for (int i = 0; i != g.Windows.Size; i++)
-   {
-      ImGuiWindow* window = g.Windows[i];
-      window->WasActive = window->Active;
-      window->Active = false;
-      window->WriteAccessed = false;
-   }
-
-   // Closing the focused window restore focus to the first active root window in descending z-order
-   if (g.NavWindow && !g.NavWindow->WasActive)
-      FocusFrontMostActiveWindow(NULL);
-
-   // No window should be open at the beginning of the frame.
-   // But in order to allow the user to call NewFrame() multiple times without calling Render(), we are doing an explicit clear.
-   g.CurrentWindowStack.resize(0);
-   g.CurrentPopupStack.resize(0);
-   ClosePopupsOverWindow(g.NavWindow);
-
-   // Create implicit window - we will only render it if the user has added something to it.
-   // We don't use "Debug" to avoid colliding with user trying to create a "Debug" window with custom flags.
-   SetNextWindowSize(ImVec2(400, 400), ImGuiCond_FirstUseEver);
-   Begin("Debug##Default");
-}
-
-static void* SettingsHandlerWindow_ReadOpen(ImGuiContext*, ImGuiSettingsHandler*, const char* name)
-{
-   ImGuiWindowSettings* settings = ImGui::FindWindowSettings(ImHash(name, 0));
-   if (!settings)
-      settings = AddWindowSettings(name);
-   return (void*)settings;
-}
-
-static void SettingsHandlerWindow_ReadLine(ImGuiContext*, ImGuiSettingsHandler*, void* entry, const char* line)
-{
-   ImGuiWindowSettings* settings = (ImGuiWindowSettings*)entry;
-   float x, y;
-   int i;
-   if (sscanf(line, "Pos=%f,%f", &x, &y) == 2)         settings->Pos = ImVec2(x, y);
-   else if (sscanf(line, "Size=%f,%f", &x, &y) == 2)   settings->Size = ImMax(ImVec2(x, y), GImGui->Style.WindowMinSize);
-   else if (sscanf(line, "Collapsed=%d", &i) == 1)     settings->Collapsed = (i != 0);
-}
-
-static void SettingsHandlerWindow_WriteAll(ImGuiContext* imgui_ctx, ImGuiSettingsHandler* handler, ImGuiTextBuffer* buf)
-{
-   // Gather data from windows that were active during this session
-   ImGuiContext& g = *imgui_ctx;
-   for (int i = 0; i != g.Windows.Size; i++)
-   {
-      ImGuiWindow* window = g.Windows[i];
-      if (window->Flags & ImGuiWindowFlags_NoSavedSettings)
-         continue;
-      ImGuiWindowSettings* settings = ImGui::FindWindowSettings(window->ID);
-      if (!settings)
-         settings = AddWindowSettings(window->Name);
-      settings->Pos = window->Pos;
-      settings->Size = window->SizeFull;
-      settings->Collapsed = window->Collapsed;
-   }
-
-   // Write a buffer
-   // If a window wasn't opened in this session we preserve its settings
-   buf->reserve(buf->size() + g.SettingsWindows.Size * 96); // ballpark reserve
-   for (int i = 0; i != g.SettingsWindows.Size; i++)
-   {
-      const ImGuiWindowSettings* settings = &g.SettingsWindows[i];
-      if (settings->Pos.x == FLT_MAX)
-         continue;
-      const char* name = settings->Name;
-      if (const char* p = strstr(name, "###"))  // Skip to the "###" marker if any. We don't skip past to match the behavior of GetID()
-         name = p;
-      buf->appendf("[%s][%s]\n", handler->TypeName, name);
-      buf->appendf("Pos=%d,%d\n", (int)settings->Pos.x, (int)settings->Pos.y);
-      buf->appendf("Size=%d,%d\n", (int)settings->Size.x, (int)settings->Size.y);
-      buf->appendf("Collapsed=%d\n", settings->Collapsed);
-      buf->appendf("\n");
-   }
+// [DEBUG] Item picker tool - start with DebugStartItemPicker() - useful to visually select an item and break into its call-stack.
+void ImGui::UpdateDebugToolItemPicker()
+{
+    ImGuiContext& g = *GImGui;
+    g.DebugItemPickerBreakId = 0;
+    if (g.DebugItemPickerActive)
+    {
+        const ImGuiID hovered_id = g.HoveredIdPreviousFrame;
+        ImGui::SetMouseCursor(ImGuiMouseCursor_Hand);
+        if (ImGui::IsKeyPressedMap(ImGuiKey_Escape))
+            g.DebugItemPickerActive = false;
+        if (ImGui::IsMouseClicked(0) && hovered_id)
+        {
+            g.DebugItemPickerBreakId = hovered_id;
+            g.DebugItemPickerActive = false;
+        }
+        ImGui::SetNextWindowBgAlpha(0.60f);
+        ImGui::BeginTooltip();
+        ImGui::Text("HoveredId: 0x%08X", hovered_id);
+        ImGui::Text("Press ESC to abort picking.");
+        ImGui::TextColored(GetStyleColorVec4(hovered_id ? ImGuiCol_Text : ImGuiCol_TextDisabled), "Click to break in debugger!");
+        ImGui::EndTooltip();
+    }
 }
 
 void ImGui::Initialize(ImGuiContext* context)
 {
-   ImGuiContext& g = *context;
-   IM_ASSERT(!g.Initialized && !g.SettingsLoaded);
-   g.LogClipboard = IM_NEW(ImGuiTextBuffer)();
-
-   // Add .ini handle for ImGuiWindow type
-   ImGuiSettingsHandler ini_handler;
-   ini_handler.TypeName = "Window";
-   ini_handler.TypeHash = ImHash("Window", 0, 0);
-   ini_handler.ReadOpenFn = SettingsHandlerWindow_ReadOpen;
-   ini_handler.ReadLineFn = SettingsHandlerWindow_ReadLine;
-   ini_handler.WriteAllFn = SettingsHandlerWindow_WriteAll;
-   g.SettingsHandlers.push_front(ini_handler);
-
-   g.Initialized = true;
+    ImGuiContext& g = *context;
+    IM_ASSERT(!g.Initialized && !g.SettingsLoaded);
+
+    // Add .ini handle for ImGuiWindow type
+    {
+        ImGuiSettingsHandler ini_handler;
+        ini_handler.TypeName = "Window";
+        ini_handler.TypeHash = ImHashStr("Window");
+        ini_handler.ClearAllFn = WindowSettingsHandler_ClearAll;
+        ini_handler.ReadOpenFn = WindowSettingsHandler_ReadOpen;
+        ini_handler.ReadLineFn = WindowSettingsHandler_ReadLine;
+        ini_handler.ApplyAllFn = WindowSettingsHandler_ApplyAll;
+        ini_handler.WriteAllFn = WindowSettingsHandler_WriteAll;
+        g.SettingsHandlers.push_back(ini_handler);
+    }
+
+#ifdef IMGUI_HAS_TABLE
+    // Add .ini handle for ImGuiTable type
+    {
+        ImGuiSettingsHandler ini_handler;
+        ini_handler.TypeName = "Table";
+        ini_handler.TypeHash = ImHashStr("Table");
+        ini_handler.ReadOpenFn = TableSettingsHandler_ReadOpen;
+        ini_handler.ReadLineFn = TableSettingsHandler_ReadLine;
+        ini_handler.WriteAllFn = TableSettingsHandler_WriteAll;
+        g.SettingsHandlers.push_back(ini_handler);
+    }
+#endif // #ifdef IMGUI_HAS_TABLE
+
+#ifdef IMGUI_HAS_DOCK
+#endif // #ifdef IMGUI_HAS_DOCK
+
+    g.Initialized = true;
 }
 
